'use strict';

yalwa.startup_country_check = (function (pub) {

	pub = pub || {};

	pub.init = function() {
		document.addEventListener("deviceready", function() { // http://stackoverflow.com/a/5018461
			window.navigator.splashscreen.hide();
			yalwa.main.load_country_infos().then(data => {
				//console.log('startup_country_check_done');
				continue_chp();
			}).fail(error => {
				//console.log('startup_country_check_fail');
				yalwa.main.open_local('network_error');
			})
		}, false);
	};
	
	function continue_chp () {
		if(yalwa.main.get('countryID')) {
			yalwa.main.tab_open();
		} else {
			if (navigator.globalization) {
				navigator.globalization.getLocaleName(function(name) {
					var potential_country_code = name.value ? name.value.match(/[A-Z]+$/) : '';
					if (potential_country_code && potential_country_code[0]) {
						if(!find_mapping(potential_country_code[0])) {
							yalwa.main.open_local('startup_country_list');
						} else {
							yalwa.main.open_local('startup_country_list');
						}
					} else {
						yalwa.main.open_local('startup_country_list');
					}
				}, function() {
					yalwa.main.open_local('startup_country_list');
				});
			} else {
				yalwa.main.open_local('startup_country_list');
			}
		}
	}

	// If geolocation found coordinates receive countryCode from google API and set startpage
	function onGeoSuccess(position) {
		jQuery.ajax({
			url: 'https://maps.googleapis.com/maps/api/geocode/json?latlng=' + position.coords.latitude + ',' + position.coords.longitude
		}).done(function (json) {
			if(json.status === 'OK') {
				jQuery.each(json.results[0].address_components, function (index, value) {
					if(jQuery.inArray('country', value.types) > -1 && value.short_name) {
						if(find_mapping(value.short_name)) {
							return false;
						}
					}
				});
				if(!yalwa.main.get('countryID')) {
					continue_chp();
				}
			} else {
				continue_chp();
			}
		}).fail(continue_chp);
	}
	
	function find_mapping(string) {
		var countryID = parseInt(yalwa.main.countryID_by_cc(string));
		if (!isNaN(countryID) && countryID > 0 && countryID < 150) {
			yalwa.main.set('countryID_temp', countryID);
			var country_name_long = '';
			var country_list = yalwa.main.get('country_list', true);
			if (country_list && country_list[countryID]) {
				country_name_long = country_list[countryID].name;
			}
			/*window.toastr.success(country_name_long + ' ' + yalwa.main.label('dialog_location_saved_text'), yalwa.main.label('dialog_location_saved_title'), {
				positionClass: 'toast-center-center'
			});*/
			//window.setTimeout(yalwa.main.tab_open, 3000);
			return true;
		}
		return false;
	}
	
	return pub;

}(yalwa.startup_country_check));